"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StructuralVariation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import opencb as opencb_2_9_3

        return {
            "breakend": opencb_2_9_3.Breakend,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import opencb as opencb_2_9_3

        return {
            "type": opencb_2_9_3.StructuralVariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.Breakend": opencb_2_9_3.Breakend,
            "org.opencb.biodata.models.variant.avro.StructuralVariantType": opencb_2_9_3.StructuralVariantType,
            "org.opencb.biodata.models.variant.avro.StructuralVariation": opencb_2_9_3.StructuralVariation,
        }

    __slots__ = [
        "breakend",
        "ciEndLeft",
        "ciEndRight",
        "ciStartLeft",
        "ciStartRight",
        "copyNumber",
        "leftSvInsSeq",
        "rightSvInsSeq",
        "type",
    ]

    def __init__(
        self,
        breakend=None,
        ciEndLeft=None,
        ciEndRight=None,
        ciStartLeft=None,
        ciStartRight=None,
        copyNumber=None,
        leftSvInsSeq=None,
        rightSvInsSeq=None,
        type=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.StructuralVariation model.

        :param breakend:
        :type breakend: None | Breakend
        :param ciEndLeft:
        :type ciEndLeft: None | int
        :param ciEndRight:
        :type ciEndRight: None | int
        :param ciStartLeft:
        :type ciStartLeft: None | int
        :param ciStartRight:
        :type ciStartRight: None | int
        :param copyNumber:
            * Number of copies for CNV variants.
        :type copyNumber: None | int
        :param leftSvInsSeq:
            * Inserted sequence for long INS         *
        :type leftSvInsSeq: None | str
        :param rightSvInsSeq:
        :type rightSvInsSeq: None | str
        :param type:
            * @deprecated
        :type type: None | StructuralVariantType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
